using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UIElements;
using UnityEngine.EventSystems;

public class DynamicFontResize : MonoBehaviour
{
    private WorldSpaceDialogueBox dialogueBox; 
    private Camera _camera; 
    private float currentdistance;
    private bool once;

    public float nearActorSize = 90;
    public float farActorSize = 120;
    public float nearTextSize = 70;
    public float farTextSize = 100; 
    public float mindistance = 1; 

    private Button[] buttons;

    public void Start() {
        _camera = Camera.main; 
        dialogueBox = GetComponent<WorldSpaceDialogueBox>();
        currentdistance = DistanceToCamera(this.gameObject.transform.position);

        if (currentdistance > mindistance) {
            once = true;
        }
        else {
            once = false;
        }
    }

    public void Update() {
        currentdistance = DistanceToCamera(this.gameObject.transform.position); 
        if (dialogueBox != null) {
            if (currentdistance > mindistance && once) {
                once = false; 
                dialogueBox.SetActorFontSize(farActorSize);
                dialogueBox.SetTextFontSize(farTextSize); 
            }

            if (currentdistance < mindistance && once == false) {
                once = true;
                dialogueBox.SetActorFontSize(nearActorSize);
                dialogueBox.SetTextFontSize(nearTextSize); 
            } 
        }    
    }

    private float DistanceToCamera(Vector3 worldPosition) =>
    Vector3.Distance(_camera.transform.position, worldPosition);

}
